﻿Imports System.IO
Imports System.Xml
Imports System.Threading
Imports System.Drawing


Public Class frmSC2Lib_XML

    Dim xmlF As FileInfo
    Dim xmlDoc As New XDocument
    Dim ImgList As ImageList
    Dim t1 As Thread

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        LoadImageList()

        Me.PictureBox1.Image = ImgList.Images("Blank")

    End Sub

    Sub LoadImageList()

        ImgList = New ImageList

        ImgList.ImageSize = New Size(24, 24)

        Dim d As DirectoryInfo = New DirectoryInfo(Application.StartupPath & "\Icons")

        For Each f In d.GetFiles

            ImgList.Images.Add(f.Name.Replace(".bmp", "").Replace(".gif", ""), Image.FromFile(f.FullName))

        Next

        Me.TreeView1.ImageList = ImgList

    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize

        Me.TreeView1.Size = New Size(Me.Width - (347 - 307), Me.Height - (474 - 383))

    End Sub

    Private Sub btnBrowse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBrowse.Click

        Dim dr As DialogResult = Me.OpenFileDialog1.ShowDialog

        If dr = Windows.Forms.DialogResult.OK Then

            Me.TreeView1.Nodes.Clear()

            xmlF = New FileInfo(OpenFileDialog1.FileName)

            lblFileName.Text = xmlF.Name

            TraverseXML()

        End If

    End Sub

    Dim XMLImg As Image

    Sub TraverseXML()

        XMLImg = Image.FromFile(Application.StartupPath & "\Icons\Build.gif")

        Me.PictureBox1.Image = XMLImg

        t1 = New Thread(AddressOf OpenXml)

        t1.Start()

    End Sub

    Sub OpenXml()

        Dim XmlReader As XmlReader = XmlReader.Create(xmlF.FullName)

        xmlDoc = XDocument.Load(XmlReader)

        Dim iNode As TreeNode = NodeSet(xmlF.Name, "XML")

        For Each xE In xmlDoc.Elements

            xmlnode(xE, iNode)

        Next

        AddNodes(iNode)

    End Sub

    Public Delegate Sub AddNode(ByRef obj As Object)

    Sub AddNodes(ByRef obj As Object)

        If Me.TreeView1.InvokeRequired Then

            Dim ad As AddNode = New AddNode(AddressOf AddNodes)

            Me.TreeView1.Invoke(ad, obj)

        Else

            Me.PictureBox1.Image = ImgList.Images("Construct")

            Me.TreeView1.BeginUpdate()

            Me.TreeView1.Nodes.Add(obj)

            Me.TreeView1.EndUpdate()

            Me.PictureBox1.Image = ImgList.Images("Built")

        End If

    End Sub

    Function NodeSet(ByRef Name As String, ByRef Type As String) As TreeNode

        Dim TreeNode As TreeNode = New TreeNode(Name)

        TreeNode.ImageKey = Type
        TreeNode.SelectedImageKey = Type

        Return TreeNode

    End Function

    Sub xmlnode(ByRef xE As XElement, ByRef TreeNode As TreeNode)

        Dim iNode As TreeNode = NodeSet(xE.Name.ToString, "Element")

        TreeNode.Nodes.Add(iNode)

        If Not xE.HasElements Then

            Dim xN As XNode

            For Each xN In xE.Nodes

                iNode.Nodes.Add(NodeSet(xN.ToString, "Value"))

            Next

        End If

        For Each xAtt In xE.Attributes

            iNode.Nodes.Add(NodeSet(xAtt.ToString, "Attribute"))

        Next

        For Each xEnest In xE.Elements

            xmlnode(xEnest, iNode)

        Next

    End Sub

End Class
